Subject: RE: bug#31130: 26; Regression: intra-glossary links broken in Emacs manual

From: Drew Adams <[email-masked]>
Date: Thu, 12 Apr 2018 10:27:30 -0700 (PDT)

> > > > 1. Trying again now, I can repro the problem only in Emacs 24.5,
> > > >    not in the more recent releases/builds.
> > >
> > > That could be, but I guess it means you reported the bug from a
> > > binary other than the one where the problem happened?
> >
> > No.  I reported it from the Emacs 26 RC1, and the problem
> > happened in that version.  And I tested it with `emacs -Q'
> > in that version.  I likely reported it (M-x report-emacs-bug)
> > using my setup, but with the same binary that I tested using
> > emacs -Q.
> 
> So you are saying that either (a) something in your setup causes this
> problem to happen, perhaps after some time the session is alive, or
> (b) something outside of Emacs causes the problem, and that something
> is not always happening, is that right?

Dunno what happened.

> > And I tested using emacs -Q also in Emacs 25.3.1,
> > 24.5, 24.4, 23.4, and even 22.3 and 20.
> 
> Which means the (b) part above is more likely the culprit?

It suggests that, if (a) and (b) are the possibilities.

> Are you reasonably sure that your reproduction steps are the same in
> all of these attempts, whether successful or not?  Or is that yet
> another potential reason for the problem to happen only sometimes?

Reasonably sure, yes.  But I will try to pay more attention
to this.

I believe that I:

1. Discovered the problem with my setup, probably in E26.
(See my other msg about why my setup led to the problem,
which I just now figured out.)

2. Used emacs -Q in various releases, from 26 (and 27?)
back through to 20.  I was both (a) checking it is still
a problem and (b) trying to find out whether it ever was
OK and if so where the regression was introduced.
I found that the problem was there starting with Emacs 24.5,
that it worked in 24.4, and that before 24.4 the text was
not linked.

> AFAIR, we ended up giving up on understanding the exact reasons back
> then as well, because you were unable to reliably reproduce the
> problem, except in an old version of Emacs or an old version of Info
> files.  Exactly like now.

That's possible.  I don't recall.
 
> Which Info files Emacs finds is determined by the code which computes
> Info-default-directory-list, and on code in info-initialize (and its
> subroutine Info-default-dirs).  In a nutshell, that makes Emacs
> consider several alternative places until it finds one that "works".
> So the answer to your question depends on the directories you have or
> don't have on your system, out of those Emacs considers, something I
> cannot know.  It also depends on whether you have INFOPATH defined in
> the environment, and if you do, what is its value.

INFOPATH is nil.
Each Emacs build is in a separate directory, and the dir contents
are what is extracted from a Windows snapshot.  I don't modify
`Info-default-directory-list' or `info-initialize' when I use
emacs -Q.  (When I use my setup, I don't modify `info-initialize',
but Cygwin does modify `Info-default-directory-list' to add
"c:/cygwin/usr/info".)

> > I don't see how different versions could show the same Info manual
> > version when each is started with emacs -Q.
> 
> If you read the code in the functions I pointed to, you will see that
> it doesn't only consider directories under the directory where you
> unzipped the archive.  It also looks in other places.

Yes, but I don't do anything (when I use emacs -Q) that affects
any of those places.